#!/bin/sh
## OpenSSL Binary
openssl_bin="/usr/bin/openssl"
## Fuer wieviele Clients soll ein Zertifikat erstellt werden
openvpn_clients="7"
## Wieviele Tage soll die VPN laufen
days="380"
SERVER_IP="server.dyndns.org"
export directory=`pwd`
export KEY_CONFIG=${directory}/openssl.cnf
export KEY_DIR=${directory}/all_keys
export KEY_SIZE=1024

export KEY_COUNTRY=DE
export KEY_PROVINCE=BY
export KEY_CITY=Hochfeld
export KEY_ORG="home"
export KEY_EMAIL="info@home.local"

###############################################################################
# AB HIER FINGER WEG AB HIER FINGER WEG AB HIER FINGER WEG AB HIER FINGER WEG #
###############################################################################

if [ "${1}" = "clean" ]; then
  echo "Loesche alle keys!"
  cd all_keys
  rm -v *
  cd ../sort_keys
  rm -rv *
  cd ..
  rm erstellungs_datum.txt
  exit 0
fi

##Dann fangen wir mal an!
date >erstellungs_datum.txt
cd all_keys
touch index.txt
echo 01 >serial
clear
echo "Erstelle OpenVPN Zertifikate:"
echo "--> my-ca"
( cat <<__CA0_Eingabe__





my-ca

__CA0_Eingabe__
) | \
${openssl_bin} req -nodes -new -x509 -days ${days} -keyout ca.key -out ca.crt\
  -config ${KEY_CONFIG} >/dev/null 2>&1
echo "--> privat my-ca"
echo 02 >serial
( cat <<__CA1_Eingabe__





my-ca



__CA1_Eingabe__
) | \
${openssl_bin} req -days ${days} -nodes -new -keyout inter.key -out inter.csr\
  -config ${KEY_CONFIG} >/dev/null 2>&1
( cat <<__CA2_Eingabe__
y
y
__CA2_Eingabe__
) | \
${openssl_bin} ca -extensions v3_ca -days ${days} -out inter.crt -in inter.csr\
  -config ${KEY_CONFIG} >/dev/null 2>&1
echo "--> 1024Bit Schluessel, das dauert einbischen!!"
${openssl_bin} dhparam -out dh1024.pem 1024 >/dev/null 2>&1
echo "--> Server "
echo 03 >serial
( cat <<__Server_Eingabe__





server



__Server_Eingabe__
) | \
${openssl_bin} req -days ${days} -nodes -new -keyout server.key\
  -out server.csr -config ${KEY_CONFIG} >/dev/null 2>&1
( cat <<__Server2_Eingabe__
y
y
__Server2_Eingabe__
) | \
${openssl_bin} ca -days ${days} -out server.crt -in server.csr\
  -config ${KEY_CONFIG} >/dev/null 2>&1
zaehler2=3
zaehler=0
while [ "${zaehler}" != "${openvpn_clients}" ]; do
  #Clients erstellen
  zaehler=`expr ${zaehler} + 1`
  zaehler2=`expr ${zaehler2} + 1`
  if [ ${zaehler2} -gt 9 ]; then
    echo ${zaehler2} >serial
  else
    echo 0${zaehler2} >serial
  fi
  echo "--> Client ${zaehler}"
  sleep 3s
  ( cat <<__Eingabe1__





client${zaehler}



__Eingabe1__
  ) | \
  ${openssl_bin} req -days ${days} -nodes -new -keyout client${zaehler}.key\
    -out client${zaehler}.csr -config ${KEY_CONFIG} >/dev/null 2>&1
  ( cat <<__Eingabe2__
y
y
__Eingabe2__
  ) | \
  ${openssl_bin} ca -days ${days} -out client${zaehler}.crt\
    -in client${zaehler}.csr -config ${KEY_CONFIG} >/dev/null 2>&1
done
cd ..

### Keys sortieren
cd sort_keys

## Server sortieren
echo -n "--> Sortiere Keys: "
mkdir server
cd server
echo -n "server, "
cp ../../all_keys/server.crt .
cp ../../all_keys/server.key .
cp ../../all_keys/ca.crt .
cp ../../all_keys/dh1024.pem .
cp ../../config/server.ovpn .
chmod 600 *
chown root *
cd ..
tar -czpf server_keys.tgz server

zaehler3=0
## Alle Clients sortieren
while [ "${zaehler3}" != "${openvpn_clients}" ]; do
  zaehler3=`expr ${zaehler3} + 1`
  echo -n "client${zaehler3}, "
  mkdir client${zaehler3}
  cd client${zaehler3}
  cp ../../all_keys/client${zaehler3}.crt .
  cp ../../all_keys/client${zaehler3}.key .
  cp ../../all_keys/ca.crt .
  sed -e "s/SERVER/${SERVER_IP}/g" \
    -e "s/CLIENT/client${zaehler3}/g" < ../../config/client.ovpn \
    >client${zaehler3}.ovpn
  chmod 600 *
  chown root *
  cd ..
  tar -czpf client${zaehler3}_keys.tgz client${zaehler3}
done
echo
echo
echo
echo
echo "WICHTIG WICHTIG WICHTIG WICHTIG WICHTIG WICHTIG"
echo "==============================================="
echo "|                                             |"
echo "|    Bitte die Datei server.ovpn anpassen!    |"
echo "|                                             |"
echo "==============================================="
echo "WICHTIG WICHTIG WICHTIG WICHTIG WICHTIG WICHTIG"
exit 0
